unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ppComm, ppRelatv, ppProd, ppClass, ppReport, ppCtrls,
  ppPrnabl, ppBands, ppCache, ppDesignLayer, ppParameter, ppDevice;

type
  TForm1 = class(TForm)
    ppReport1: TppReport;
    Button1: TButton;
    ppParameterList1: TppParameterList;
    ppDesignLayers1: TppDesignLayers;
    ppDesignLayer1: TppDesignLayer;
    ppHeaderBand1: TppHeaderBand;
    ppDetailBand1: TppDetailBand;
    ppFooterBand1: TppFooterBand;
    ppShape1: TppShape;
    ppLabel1: TppLabel;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ppDetailBand1BeforePrint(Sender: TObject);
    procedure ppShape1DrawCommandClick(Sender, aDrawCommand: TObject);
    procedure ppShape1DrawCommandCreate(Sender, aDrawCommand: TObject);
  private
    FHighlightList: TStringList;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  ppDrwCmd;

{$R *.dfm}

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FHighlightList.Free;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FHighlightList := TStringList.Create;

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  FHighlightList.Clear;
  ppReport1.Print;

end;

procedure TForm1.ppDetailBand1BeforePrint(Sender: TObject);
begin
  //Only highlight the bands in the list
  if FHighlightList.IndexOf(IntToStr(ppReport1.DetailBand.Count)) > -1 then
    ppShape1.Brush.Color := clRed
  else
    ppShape1.Brush.Color := clWhite;

end;

procedure TForm1.ppShape1DrawCommandClick(Sender, aDrawCommand: TObject);
var
  liBandNo: Integer;
begin

  if aDrawCommand is TppDrawShape then
    begin
      liBandNo := TppDrawShape(aDrawCommand).Tag;

      //Add or remove the detail number from the list
      if FHighlightList.IndexOf(IntToStr(liBandNo)) > -1 then
        FHighlightList.Delete(FHighlightList.IndexOf(IntToStr(liBandNo)))
      else
        FHighlightList.Add(IntToStr(TppDrawShape(aDrawCommand).Tag));

      ppReport1.Reset;
      ppReport1.Engine.Reset;

      TppDrawShape(aDrawCommand).RedrawPage := True;
    end;

end;

procedure TForm1.ppShape1DrawCommandCreate(Sender, aDrawCommand: TObject);
begin
  //Assign detail count to the drawcommand.tag for later use
  TppDrawCommand(aDrawCommand).Tag := ppReport1.DetailBand.Count - 1;

end;

end.
